#include <l4/types.h>
#include <l4/ipc.h>
#include <l4/syscalls.h>

#include <thread.h>


extern void __asm_thread_start(void);

BOOL CreateThread(int ThreadNr, int Prio, void* pFunction, void* pStack, void* pParam) {
  qword_t dummy; 
  l4_threadid_t tmpPager, tmpPreempter, tmpMyself;
  qword_t *Stack = (qword_t *)pStack;

  tmpPager = tmpPreempter = L4_INVALID_ID;
  tmpMyself = l4_myself();
  l4_thread_ex_regs (tmpMyself.id.lthread, (qword_t)-1, (qword_t)-1, 
                     &tmpPreempter, &tmpPager, &dummy, &dummy);

  *Stack-- = (qword_t)pParam;
  *Stack-- = (qword_t)pFunction;

  l4_thread_ex_regs (ThreadNr, (qword_t)__asm_thread_start, (qword_t)Stack, 
		     &tmpPreempter, &tmpPager, &dummy, &dummy);

  return TRUE;
}


void Sleep(int Mantisse, int Exponent) {
  l4_alpha_ipc_receive(l4_myself(), NULL, NULL, L4_IPC_TIMEOUT (0, 0, Mantisse, Exponent, 0,0));
}

int GetCurrentTaskNr(void) {
  return l4_myself().id.task;
}

int GetCurrentThreadNr(void) {
  return l4_myself().id.lthread;
}

void SwitchToThread(int ThreadNr) {
  l4_threadid_t tmpMyself=l4_myself();
  tmpMyself.id.lthread=ThreadNr;
  l4_thread_switch(tmpMyself);
}

BOOL TerminateThread(int ThreadNr) {
  if (!ThreadExists(ThreadNr)) return FALSE;
  
  return TRUE;
}

BOOL TaskExists(int TaskID) {
  return TRUE;
}

BOOL ThreadExists(int ThreadNr) {
  qword_t tmpDummy1, tmpPC;
  l4_threadid_t tmpDummy2;
  tmpDummy2=L4_INVALID_ID;
  l4_thread_ex_regs(ThreadNr, tmpPC, tmpDummy1, &tmpDummy2, &tmpDummy2, &tmpPC, &tmpDummy1);
  if (tmpPC==-1) return FALSE; /* don't exist in L4 */
  /* now check, if the thread is not sleeping... */
  return TRUE;
}

BYTE GetThreadPrio(int ThreadNr) {
/*  l4_threadid_t tmpThread;
  l4_sched_param_t tmpParam;
  tmpThread.id.lthread=ThreadNr;
  l4_thread_schedule(tmpThread, (qword_t)-1, NULL, NULL, &tmpParam);
  return tmpParam.sp.prio;*/
  return 0;
}

__asm__  (
          "__asm_thread_start:                          \n\t"
          "ldgp $29,0($27)                              \n\t"
          "ldq $16, 16($30)                              \n\t"
	  "ldq $27, 8($30)                              \n\t"
	  "addq $30, 16, $30                            \n\t"
          "jsr $26, ($27)                               \n\t"
	  "lda $27, __ThreadStop			\n\t"
	  "jsr $31, ($27), __ThreadStop                     "
          );

void __ThreadStop(void) {
  l4_alpha_ipc_receive(l4_myself(), NULL, NULL, L4_IPC_NEVER);
  while(1);
}

