#include <l4/types.h>
#include <l4/ipc.h>
#include <l4/syscalls.h>

#include <l4/kdebug.h>

#include <thread.h>

#define MAX_COUNT 0x10000

L4_INLINE void 
l4dbg_write_string (const char *str);

L4_INLINE void 
l4dbg_print_hex (long x, long bits);


volatile qword_t* ptr;
volatile qword_t* ptr2;
volatile qword_t* indexptr;

volatile char *memory  = (char *)0;

long int runsp =     0x800000;
const int memtest = 0x2000000;

qword_t memaddr=0x03000000;

qword_t ThreadStack1[0x02000];
qword_t ThreadStack2[0x02000];
qword_t ThreadStack3[0x02000];

inline void l4_grant_task (l4_threadid_t task, l4_taskid_t destination)
{
  l4_task_new (task, destination.thread_id, 0, L4_NIL_ID);
}

extern "C" unsigned rpcc(void);


inline unsigned rpcc (void)
{
  unsigned ret;

  __asm__  __volatile__("rpcc %0" : "=r"(ret));
  return ret;
}


void printdec (long i)
{
        char str[32];
        long r;
        
        if (!i) {
                l4dbg_write_string ("0");
                return;
        }   
                
        str[31] = 0;
        str[30] = '0';  
        for (r = 30; r && i; r--) {
                str[r] = '0' + (char)(i % 10);
                i = i / 10;
        }
        l4dbg_write_string (&(str[r+1]));
}

void 
CreateMappingsHorizontal() 
{
  l4_ipcregs_t rex; 
  l4dbg_write_string("CreateMappingsHorizontal\n\r");
  char tmp;   
  l4_threadid_t tmpId=l4_myself();
  tmpId.id.task=2;
  tmpId.id.lthread=5;

  for (int j=1;j <= 0x10000;j=j<<1) {
    for (int i=0;i<j;i++) {
      tmp+=memory[memtest+i*0x02000];
    }
//    l4dbg_write_string("Mappings Associated!\n\r");
    rex.val[0]=j;
    l4_alpha_ipc_call(tmpId, NULL, &rex, NULL, &rex, L4_IPC_NEVER);
  }
  while(1);
  
}

void 
CreateMappingsVertical() 
{
  l4_ipcregs_t regs;
  l4_threadid_t tmpId, from;
  
  tmpId=l4_myself();
  tmpId.id.task=2;
  tmpId.id.lthread=3;
  int totalCount=MAX_COUNT;

  char b;
  b+=memory[memaddr];
  if (l4_myself().id.lthread==2) {
    l4dbg_write_string("Sender\n\r");
    regs.val[0]=memaddr | (13 << 2) | 1;
    regs.val[1]=(memaddr + 0x02000);
    
    l4dbg_write_string(" XX ");
    l4dbg_print_hex(regs.val[0], 64);
    l4dbg_write_string(" XX ");
    l4dbg_print_hex(regs.val[1], 64);

    l4_alpha_ipc_send(tmpId, L4_IPC_SHORT_FPAGE, &regs, L4_IPC_NEVER);
  }
  else {
    // partner is 4!
    l4dbg_write_string("Receiver\n\r");
  }

  while(totalCount--) {
    l4_alpha_ipc_wait(&from, L4_IPC_MAPMSG (0, 63), &regs, L4_IPC_NEVER);
    //if (l4_myself().id.lthread==2) l4dbg_write_string("#");
    //else l4dbg_write_string("$");
    
    /*l4dbg_print_hex(from.thread_id, 64);
    l4dbg_write_string(" - ");
    l4dbg_print_hex(regs.val[0], 64);
    l4dbg_write_string(" - ");
    l4dbg_print_hex(regs.val[1], 64);*/
    //regs.val[0]=(regs.val[0] & ~0x1fff) | (13 << 2) | 1;
    //regs.val[1]=regs.val[0] + 0x02000;
    regs.val[0]+=0x02000;
    regs.val[1]+=0x02000;
    //    b+=memory[regs.val[0]]; 
    
    //l4dbg_write_string("\n\r");
    l4_alpha_ipc_send(from, L4_IPC_SHORT_FPAGE , &regs, L4_IPC_NEVER);
  }
  if (l4_myself().id.lthread==3) {
    tmpId=l4_myself();
    tmpId.id.lthread=5;
    l4_alpha_ipc_send(tmpId, NULL, &regs, L4_IPC_NEVER);
  }
  //enter_kdebug();
  //while(1);
}


void 
FlushThread() 
{
  l4_threadid_t f;
  l4_ipcregs_t rex;

  while(1) {
    l4_alpha_ipc_wait (&f, NULL, &rex, L4_IPC_NEVER);
//    l4dbg_write_string("Flusher got Msg!\n\r");
  // l4_fpage_unmap_easy(memtest, 1, 0, 0);
    qword_t t1=rpcc();
    l4_fpage_unmap((l4_fpage_t){fpage:((memaddr+0x02000) | (13 << 2)) | 0}, 0);
    qword_t t2=rpcc();
    printdec (rex.val[0]);
    l4dbg_write_string(" ");
    printdec(t2-t1);
    l4dbg_write_string("\n\r");
    l4_alpha_ipc_send (f, NULL, NULL, L4_IPC_NEVER);
  }

}
void 
FlushThread2() 
{
  l4_threadid_t f;
  l4_ipcregs_t rex;
  qword_t t1, t2;

  l4dbg_write_string("FlushThread started\n\r");
  l4_alpha_ipc_wait (&f, NULL, &rex, L4_IPC_NEVER);
  l4dbg_write_string("Flusher got Msg!\n\r");
  // l4_fpage_unmap_easy(memtest, 1, 0, 0);
  qword_t memend=rex.val[1];
  l4dbg_write_string("End of mapping area: ");
  l4dbg_print_hex(memend, 64);
  l4dbg_write_string("\n\r");
  for (int i=1, j=MAX_COUNT;j>0;j-=i,i=i<<1) {
    qword_t flushaddr=memend-(i)*0x02000;
    t1=rpcc();
    l4_fpage_unmap((l4_fpage_t){fpage:(flushaddr | (13 << 2)) | 0}, 0);
    t2=rpcc();
    memend=flushaddr;
    printdec (i); 
    l4dbg_write_string(" ");
    printdec(t2-t1);
    l4dbg_write_string("\n\r");
    //enter_kdebug();

  }
  l4dbg_write_string ("READY");
  enter_kdebug();
  //l4_alpha_ipc_send (f, NULL, NULL, L4_IPC_NEVER);
}

main(void) {
  l4_threadid_t ms, from;
  l4_taskid_t tid;
  l4_ipcregs_t regs; 
  char d;

  ptr2=0x0310000;
  qword_t j=0;
  
  __asm__ ("lda $0, runsp; ldq $30, 0($0)\n");
  runsp += 0x2000;

  ms=tid=l4_myself();
  l4dbg_print_hex(tid.id.task, 32);
  l4dbg_write_string(" is task id\n\r");

  if (tid.id.task==5) CreateMappingsHorizontal();
  tid.id.task=5;
  //l4_task_new (tid, 0x40, 0x222000, ms);
  l4dbg_write_string("Main\n\r");

  CreateThread(5, 0, FlushThread2, &ThreadStack1[0x2000], NULL);
  CreateThread(2, 0, CreateMappingsVertical, &ThreadStack2[0x2000], NULL);
  CreateThread(3, 0, CreateMappingsVertical, &ThreadStack3[0x2000], NULL);
  
  l4dbg_write_string("waiting for mappings");
  // touching the pages to be mapped in own address-space
  /*for (int i=0; i<MAX_COUNT; i++) {
    j+=*ptr2;
    ptr2+=0x02000;
  }
  */
  char bla=0;
  bla+=memory[memtest];
  l4dbg_write_string("bla2");
  l4_alpha_ipc_wait(&from, NULL, &regs, L4_IPC_NEVER);
  while(1) {
    if (regs.val[0]<memtest) {
      regs.val[0] = 
	regs.val[1] = (regs.val[0] & ~0x1fff) | (13 << 2) | 1;
      bla+=memory [regs.val[0]];
    } else {
       regs.val[1] = (regs.val[0] & ~0x1fff);
       regs.val[0] = memtest | (13 << 2) | 1;
       bla+=memory [regs.val[0]];
     }

//    l4dbg_write_string("#");
    l4_alpha_ipc_reply_and_wait(from, 
				L4_IPC_SHORT_FPAGE,
				&regs,
				&from,
				L4_IPC_SHORT_FPAGE,
				&regs,
				L4_IPC_NEVER);
  }
			       
}

