#include <l4/types.h>
#include <l4/ipc.h>
#include <l4/syscalls.h>

#include <thread.h>

#define MAX_COUNT 32000

L4_INLINE void 
l4dbg_write_string (const char *str);

L4_INLINE void 
l4dbg_print_hex (long x, long bits);

qword_t buffer[MAX_COUNT*2];

volatile qword_t* ptr;
volatile qword_t* indexptr;

inline unsigned rpcc (void)
{
  unsigned ret;

  __asm__  __volatile__("rpcc %0" : "=r"(ret));
  return ret;
}


void printdec (int i)
{
        char str[32];
        int r;
        
        if (!i) {
                l4dbg_write_string ("0");
                return;
        }   
                
        str[31] = 0;
        str[30] = '0';
        for (r = 30; r && i; r--) {
                str[r] = '0' + (char)(i % 10);
                i = i / 10;
        }
        l4dbg_write_string (&(str[r+1]));
}


main (void) { 
  ptr=0x0310000;
  indexptr=0x0300000;
  *indexptr=(qword_t)&buffer[1];

  qword_t j=0;
  int i;
  for (i=0;i<MAX_COUNT*2;i++) {
    buffer[i]=0;
  }
  l4dbg_write_string("Initialized\n\r");
    
  qword_t t1, t2;

  for (i=0; i<MAX_COUNT; i+=2) {
    *indexptr=(qword_t)&buffer[i+1];
    t1=rpcc();
    j+=*ptr;
    t2=rpcc();
    ptr+=0x02000;
    buffer[i]=t2-t1;
   
  }
  l4dbg_write_string("Finished!");
  for (i=0; i<MAX_COUNT; i+=2) {
    printdec(buffer[i]);
    l4dbg_write_string("\t");
    printdec(buffer[i+1]);
    l4dbg_write_string("\n\r");
  }
  
   
  while(1);
}

