#include <l4/types.h>
#include <l4/ipc.h>
#include <l4/syscalls.h>

#include <thread.h>

#define MAX_COUNT 4000

L4_INLINE void 
l4dbg_write_string (const char *str);

L4_INLINE void 
l4dbg_print_hex (long x, long bits);

qword_t buffer[MAX_COUNT*2];

volatile qword_t* ptr;
volatile qword_t* ptr2;
volatile qword_t* indexptr;

volatile char *memory  = (char *)0;

long int runsp = 0x800000;

inline void l4_grant_task (l4_threadid_t task, l4_taskid_t destination)
{
  l4_task_new (task, destination.thread_id, 0, L4_NIL_ID);
}

inline unsigned rpcc (void)
{
  unsigned ret;

  __asm__  __volatile__("rpcc %0" : "=r"(ret));
  return ret;
}


void printdec (int i)
{
        char str[32];
        int r;
        
        if (!i) {
                l4dbg_write_string ("0");
                return;
        }   
                
        str[31] = 0;
        str[30] = '0';
        for (r = 30; r && i; r--) {
                str[r] = '0' + (char)(i % 10);
                i = i / 10;
        }
        l4dbg_write_string (&(str[r+1]));
}


main2 (void) {
  l4dbg_write_string("Toucher initializing...\n\r");
  ptr=0x0310000;
  indexptr=0x0300000;
  *indexptr=(qword_t)&buffer[1];

  qword_t j=0;
  int i;
  for (i=0;i<MAX_COUNT*2;i++) {
    buffer[i]=0;
  }
  l4dbg_write_string("Toucher initialized\n\r");
    
  qword_t t1, t2;

  for (i=0; i<MAX_COUNT*2; i+=2) {
    *indexptr=(qword_t)&buffer[i+1];
    t1=rpcc();
    j+=*ptr;
    t2=rpcc();
    ptr+=0x02000;
    buffer[i]=t2-t1;
   
  }
  l4dbg_write_string("Finished!");
  for (i=0; i<MAX_COUNT*2; i+=2) {
    printdec(buffer[i]);
    l4dbg_write_string("\t");
    printdec(buffer[i+1]);
    l4dbg_write_string("\n\r");
  }
  
   
  while(1);
}

main(void) {
  l4_threadid_t ms, from;
  l4_taskid_t tid;
  l4_ipcregs_t regs; 
  char d;

  ptr2=0x0310000;
  qword_t j=0;

  __asm__ ("lda $0, runsp; ldq $30, 0($0)\n");
  runsp += 0x2000;

  ms=tid=l4_myself();
  l4dbg_print_hex(tid.id.task, 32);
  l4dbg_write_string(" is task id\n\r");

  if (tid.id.task==5) main2();
  tid.id.task=5;
  l4_task_new (tid, 0x40, 0x222000, ms);
  l4dbg_write_string("Pager initialized\n\r");


  for (int i=0; i<MAX_COUNT; i++) {
    j+=*ptr2;
    ptr2+=0x02000;
  }

  while (1) {
    l4_alpha_ipc_wait (&from,
                       NULL,
                       &regs,
                       L4_IPC_NEVER);

    d+=memory[regs.val[0]];
    
    regs.val[0] = 
     regs.val[1] = (regs.val[0] & ~0x1fff) | (13 << 2);

    l4_alpha_ipc_send (from,
                       (void*)((qword_t)(NULL) | 0x02),
                       &regs,
                       L4_IPC_NEVER);
  }
}

