#include <l4/types.h>
#include <l4/ipc.h>
#include <l4/syscalls.h>

#include <thread.h>

L4_INLINE void 
l4dbg_write_string (const char *str);

L4_INLINE void 
l4dbg_print_hex (long x, long bits);

volatile long abc;

class MyThread : public Thread
{
public:
  MyThread (unsigned nr)
    : Thread (nr) {};

  virtual void ThreadFunction (void)
    {
      l4dbg_write_string ("Blah\n\r");
      l4dbg_print_hex (GetID().thread_id, 64);
      Thread tmpThread(1);
      while (1) {
	l4dbg_write_string("#");
	tmpThread.SendShort(L4_IPC_NEVER);
//	l4dbg_write_string(".");
      }
    }
};


class RecvThread : public Thread
{
public:
  RecvThread (unsigned nr)
    : Thread (nr) {};

  virtual void ThreadFunction (void)
    {
      l4dbg_write_string ("Receive-Thread\n\r");
      l4dbg_print_hex (GetID().thread_id, 64);
      while(1) {
	l4_threadid_t tmpThread;
	WaitShort(L4_IPC_NEVER, &tmpThread);
	//l4dbg_write_string ("received anything from");
	//l4dbg_print_hex(tmpThread.thread_id, 64);
	l4dbg_write_string("$");
      }
    }
};

long stack1[1024];
long stack2[1024];
long stack3[1024];

int main ()
{
  MyThread thread2(2);
  RecvThread thread1(1);
  thread1.Create(&stack1[1023]);
  thread2.Create(&stack2[1023]);

  while (1);
}



